#include <avr/io.h>

#define F_CPU 1000000
#include <util/delay.h>

#define TEST  5

int main(void) {

	uint8_t i;

	DDRB = 0xFF;

#if TEST == 1	
	// init timer 0, fast PWM, timer mode 3
	// use OCR0B as test output
	uint8_t	pwm[8] = {0, 1, 2, 3, 252, 253, 254, 255};
	TCCR0A = (1<<COM0B1) | (1<<WGM01) | (1<<WGM00);
	TCCR0B = (1<<CS00);		// prescaler 1

#endif

#if TEST == 2	
	// init timer 0, phase correct PWM, timer mode 1
	// use OCR0B as test output
	uint8_t	pwm[8] = {0, 1, 2, 3, 252, 253, 254, 255};
	TCCR0A = (1<<COM0B1) | (1<<WGM00);
	TCCR0B = (1<<CS00);		// prescaler 1

#endif

#if TEST == 3
	// init timer 0, phase correct PWM, timer mode 5
	// use OCR0B as test output
	uint8_t	pwm[8] = {0, 1, 2, 3, 97, 98, 99, 100};
	TCCR0A = (1<<COM0B1) | (1<<WGM00);
	TCCR0B = (1<<WGM02) | (1<<CS00);		// prescaler 1
	OCR0A = 100;
#endif

#if TEST == 4
	// init timer 1, normal mode, PWM
	// use OCR1B as test output
	uint8_t	pwm[8] = {0, 1, 2, 3, 252, 253, 254, 255};
	TCCR1 = (1<<CS10);
	GTCCR = (1<<PWM1B) | (1<< COM1B1);
#endif

#if TEST == 5
	// init timer 1, CTC mode, PWM
	// use OCR1B as test output
	uint8_t	pwm[8] = {0, 1, 2, 3, 97, 98, 99, 100};
	TCCR1 = (1<<CS10) | (1<<CTC1); 
	GTCCR = (1<<PWM1B) | (1<< COM1B1);
	OCR1C = 99;
#endif

	while(1) {
		for (i=0; i < sizeof(pwm); i++) {
			OCR0B = pwm[i];
			OCR1B = pwm[i];
			_delay_ms(2000);
		}
	}
}

